/****
 *
 * Exemplo: Funes de Disperso Prontas: Funo de Disperso
 *          SAX
 *
 * Seo: B.3
 *
 * Descrio: Implementao da funo de disperso SAX
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoSAX(): Implementao da funo de disperso SAX
 *
 * Parmetros:
 *      chave (entrada) - a chave cujo valor de disperso
 *                        ser calculado
 *
 * Retorno: O valor de disperso calculado
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoSAX(const char *chave)
{
   unsigned int dispersao = 0;

   while (*chave)
      dispersao ^= (dispersao << 5) + (dispersao >> 2) + *chave++;

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoSAX()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n   >>>> Usando Dispersao SAX <<<<\n");
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoSAX("bola") );
   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoSAX("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

   >>>> Usando Dispersao SAX <<<<

>>> Dispersao de "bola" = 3367701
>>> Dispersao de "loba" = 4033893

**********************************************************/
