#ifndef _Tabela_H_
#define _Tabela_H_

#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

typedef struct rotTabelaIdx *tTabelaIdx;

/******************* Aluses de Funes *******************/

extern tTabelaIdx CriaTabelaIdx(void);
extern void DestroiTabelaIdx(tTabelaIdx tabela);
extern int ComprimentoIdx(tTabelaIdx tabela);
extern tCEP_Ind ObtemElementoIdx(tTabelaIdx tabela, int indice);
extern tCEP_Ind RemoveElementoIdx(tTabelaIdx tabela, int indice);
extern int EstaVaziaIdx(tTabelaIdx tabela);
extern void AcrescentaElementoIdx(tTabelaIdx tabela, const tCEP_Ind *elemento);

extern void InsereEmOrdemIdx(tTabelaIdx tabela, const tCEP_Ind *elemento);
extern int BuscaBinariaIdx(tTabelaIdx tabela, tCEP chave);
extern int BuscaInterpolacaoIdx(tTabelaIdx tabela, tCEP chave);
extern int BuscaSequencialIdx(tTabelaIdx lista, tCEP chave);
extern void OrdenaTabelaIdx( tTabelaIdx lista,
                             int (*FComp) (const void *, const void *) );
extern int BuscaBinariaIdx2( tTabelaIdx tabela, tCEP chave,
                             int (*FComp) (const void *, const void *) );

#endif
