#ifndef _Lista_H_
#define _Lista_H_

#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n do nvel 0 */
typedef struct rotNoLS {
           tCEP_Ind         conteudo; /* Contedo efetivo    */
           struct rotNoLS **proximo;  /* Prximo n da lista */
        } tNoListaComSalto;

   /* Tipo de lista com saltos */
typedef struct {
           tNoListaComSalto *cabeca;   /* Cabea da lista         */
           int               nivel;    /* Nvel corrente da lista */
           int               nivelMax; /* Nvel mximo da lista   */
        } tListaComSaltos;

/************************* Aluses ************************/

extern void ApresentaComprimentosPorNivel(tListaComSaltos lista);
extern void ApresentaRelacoesEntreNiveis(tListaComSaltos lista);
extern void ApresentaNiveis(tListaComSaltos lista);

extern void IniciaListaComSaltos( tListaComSaltos *lista, int maxRegs );
extern int EstaVaziaListaComSaltos(tListaComSaltos lista);
extern int ComprimentoListaComSalto(tListaComSaltos lista);
extern int BuscaListaComSaltos(tListaComSaltos lista, tCEP chave);
extern tNoListaComSalto *InsereListaComSaltos( tListaComSaltos *lista,
                                                 tCEP_Ind conteudo );
extern int RemoveListaComSaltos( tListaComSaltos *lista, tCEP chave );
extern tCEP_Ind *ProximoListaComSaltos(tListaComSaltos lista);
extern void DestroiListaComSaltos(tListaComSaltos lista);

#endif
