#ifndef _ArvoreBB_H_
#define _ArvoreBB_H_

#include "Registros.h" /* Interface do mdulo Registros */
#include <stdio.h>     /* FILE */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tChave chave; /* CEP */
           int    valor; /* ndice do CEP no arquivo */
        } tConteudo;

typedef enum {ESQUERDA = 0, DIREITA = 1} tDirecao;

typedef struct noBB2 {
           tConteudo     conteudo; /* Contedo do n */
           struct noBB2 *filho[2]; /* Os filho do n */
        } tNoBB2;

typedef struct rotArvoreBB2 *tArvoreBB2;

typedef void (*tOperacao) (tConteudo, FILE*);

/************************* Aluses ************************/

extern tArvoreBB2 CriaArvoreBB2(void);
extern int EstaVaziaArvoreBB2(tArvoreBB2 arvore);
extern void DestroiArvoreBB2( tArvoreBB2 arvore );
extern tConteudo *BuscaArvoreBB2( tArvoreBB2 arvore,
                                  tChave chave );
extern int InsereArvoreBB2( tArvoreBB2 arvore,
                            const tConteudo *conteudo );
extern int RemoveArvoreBB2(tArvoreBB2 arvore, tChave chave);
extern int AlteraConteudoArvoreBB2( tArvoreBB2 arvore,
                                    tChave chave,
                                    tConteudo *conteudo );
extern int NumeroNosArvoreBB2(tArvoreBB2 arvore);
extern void CaminhamentoInfixo( tArvoreBB2 arvore, tOperacao op,
                                FILE *stream );
extern int ProfundidadeArvoreBB2(tArvoreBB2 arvore);
extern tConteudo *MenorChaveArvoreBB2(tArvoreBB2 arvore);
extern tConteudo *MaiorChaveArvoreBB2(tArvoreBB2 arvore);
extern void AvaliaArvoreBB2(tArvoreBB2 arvore);

#endif
