/****
 *
 * Arquivo ArvoreAVL.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreAVL
 *
 ****/

#ifndef _ArvoreAVL_
#define _ArvoreAVL_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro ara n de uma rvore binria  */
typedef struct rotNoAVL {
           struct rotNoAVL *esquerda, *direita; /* Filhos deste n */
           tCEP_Ind         conteudo; /* Par chave/ndice */
           int              altura; /* Altura da rvore que  */
                                    /* tem este n como raiz */
        } tNoAVL, *tArvoreAVL;

typedef void (*tOperacao) (tCEP_Ind, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreAVL(tArvoreAVL *arvore);
extern int NumeroNosArvoreAVL(tArvoreAVL arvore);
extern int AlturaAVL(tArvoreAVL arvore);
extern tCEP_Ind *BuscaArvoreAVL( tArvoreAVL arvore, tCEP chave );
extern tArvoreAVL InsereAVL( tArvoreAVL arvore, const tCEP_Ind *conteudo );
extern tArvoreAVL RemoveAVL(tArvoreAVL arvore, tCEP chave);
extern int AlteraConteudoArvoreAVL( tArvoreAVL *arvore, tCEP chave,
                                    tCEP_Ind *conteudo );
extern void DestroiArvoreAVL(tArvoreAVL arvore);
extern void CaminhamentoInfixoAVL(tArvoreAVL arvore, tOperacao op, FILE *stream);
extern tCEP_Ind *MenorChaveAVL(tArvoreAVL p);
extern tCEP_Ind *MaiorChaveAVL(tArvoreAVL p);

#endif
