/****
 *
 * Arquivo ArvoreAVL.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreAVL2
 *
 ****/

#ifndef _ArvoreAVL2_
#define _ArvoreAVL2_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tChave chave;     /* CEP */
           int    indiceCEP; /* ndice do CEP no arquivo */
        } tConteudo;

   /* Tipo de n e tipo de ponteiro */
   /* para n de uma rvore AVL     */
typedef struct no {
           tConteudo  conteudo;
           int        altura;
           struct no *filho[2];
        } tNoAVL2, *tArvoreAVL2;

typedef void (*tOperacao) (tConteudo, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreAVL(tArvoreAVL2 *arvore);
extern int NumeroNosArvoreAVL(tArvoreAVL2 arvore);
extern int ProfundidadeArvoreAVL(tArvoreAVL2 arvore);
extern tConteudo *BuscaArvoreAVL( tArvoreAVL2 arvore,
                                  tChave chave );
extern tArvoreAVL2 InsereAVL( tArvoreAVL2 arvore,
                              const tConteudo *conteudo );
extern tArvoreAVL2 RemoveAVL(tArvoreAVL2 arvore, tChave chave);
extern int EstaVaziaLSE(tArvoreAVL2 arvore);
extern int AlteraConteudoArvoreAVL( tArvoreAVL2 *arvore,
                                    tChave chave,
                                    tConteudo *conteudo );
extern void DestroiArvoreBin(tArvoreAVL2 arvore);
extern void CaminhamentoInfixo( tArvoreAVL2 arvore, tOperacao op,
                                FILE *stream );
extern tConteudo *MenorChave(tArvoreAVL2 p);
extern tConteudo *MaiorChave(tArvoreAVL2 p);

#endif
