/****
 *
 * Arquivo ArvoreBB.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreBB
 *
 ****/

#ifndef _ArvoreBB_
#define _ArvoreBB_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n de uma rvore binria  */
typedef struct rotNoABB {
           struct rotNoABB *esquerda;
           tCEP_Ind         conteudo;
           struct rotNoABB *direita;
        } tNoArvoreBB, *tArvoreBB;

typedef void (*tOperacao) (tCEP_Ind, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreBB(tArvoreBB *arvore);
extern int NumeroNosArvoreBB(tArvoreBB arvore);
extern int AlturaArvoreBB(tArvoreBB arvore);
extern tCEP_Ind *BuscaArvoreBB(tArvoreBB arvore, tCEP chave);
extern int InsereArvoreBB( tArvoreBB *arvore, const tCEP_Ind *conteudo );
extern int RemoveArvoreBB(tArvoreBB *arvore, tCEP chave);
extern int AlteraConteudoArvoreBB( tArvoreBB *arvore, tCEP chave,
                                   const tCEP_Ind *conteudos );
extern void DestroiArvoreBB(tArvoreBB arvore);
extern void CaminhamentoInfixoBB( tArvoreBB arvore, tOperacao op, FILE *stream );
extern tCEP_Ind *MenorChaveArvoreBB(tArvoreBB p);
extern tCEP_Ind *MaiorChaveArvoreBB(tArvoreBB p);

#endif
