/****
 *
 * Exemplo: Funo de disperso para estruturas
 *
 * Seo: 7.2.2
 *
 * Descrio: Implementao de uma funo de disperso para estruturas
 *
 ****/

#include <stdio.h>   /* Entrada e sada             */

typedef struct {
           int dia;
           int mes;
           int ano;
        } tData;

/****
 *
 * DispersaoData(): Calcula o valor de disperso de uma estrutura
 *
 * Parmetros:
 *     *c (entrada) - a estrutura
 *      tam (entrada) - tamanho da tabela de disperso
 *
 * Retorno: O valor de disperso calculad
 *
 ****/
unsigned DispersaoData(const tData *c, int tam)
{
   unsigned b = 31; /* Base */

   return (((c->dia*b + c->mes)%tam)*b + c->ano)%tam;
}

/****
 *
 * main(): Testa a funo DispersaoData()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   tData c = {21, 12, 1980};
   int   tamTab = 113;

   printf( "\n>>> Valor de dispersao: %u\n",
           DispersaoData(&c, tamTab) );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Valor de dispersao: 46

**********************************************************/
