/****
 *
 * Exemplo: Mtodos de Clculo de Disperso: Mtodo de Soma
 *
 * Seo: 7.2.3
 *
 * Descrio: Implementao de uma funo disperso
 *            usando o mtodo de soma
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoAditiva(): Calcula o valor de disperso de um
 *                     string usando o mtodo da soma
 *
 * Parmetros:
 *      chave (entrada) - o string
 *
 * Retorno: O valor de disperso calculado
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoAditiva(const char *chave)
{
   unsigned int dispersao = 0;

   while (*chave)
       dispersao += *chave++;

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoAditiva()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoAditiva("bola") );

   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoAditiva("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Dispersao de "bola" = 414
>>> Dispersao de "loba" = 414

**********************************************************/
