/****
 *
 * Exemplo: Mtodos de Clculo de Disperso: Mtodo Polinomial
 *
 * Seo: 7.2.3
 *
 * Descrio: Implementao de uma funo disperso
 *            usando o mtodo polinomial
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoPolinomial(): Calcula o valor de disperso de um
 *                        string usando o mtodo polinomial
 *
 * Parmetros:
 *      chave (entrada) - o string
 *
 * Retorno: Nada
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoPolinomial(const char *chave)
{
   unsigned int dispersao = 0,
                base = 2,
                primo = 31;

   while (*chave)
      dispersao = (dispersao*base + *chave++)%primo;

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoPolinomial()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoPolinomial("bola") );

   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoPolinomial("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Dispersao de "bola" = 22
>>> Dispersao de "loba" = 20

**********************************************************/
