/****
 *
 * Exemplo: Mtodos de Clculo de Disperso: Mtodo de Multiplicao
 *
 * Seo: 7.2.3
 *
 * Descrio: Implementao de uma funo disperso
 *            usando o mtodo de multiplicao
 *
 ****/

#include <stdio.h>
#include <math.h>

/****
 *
 * DispersaoMultiplicacao(): Calcula o valor de disperso
 *                           de uma chave inteira usando o
 *                           mtodo de multiplicao
 *
 * Parmetros:
 *      chave (entrada) - a chave
 *
 * Retorno: Nada
 *
 ****/
unsigned DispersaoMultiplicacao(unsigned chave, unsigned tamTabela)
{
   double a = (sqrt(5) - 1)/2,
          pInteira, pFracionaria;

   pFracionaria = modf(chave*a, &pInteira);

   return (unsigned) floor(tamTabela*pFracionaria);
}

/****
 *
 * main(): Testa a funo DispersaoMultiplicacao()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   unsigned tamTabela = 2000;

   printf( "\n>>> Dispersao de 6341 = %u\n",
           DispersaoMultiplicacao(6341, tamTabela) );

   return 0;
}

/****************** Resultado do Programa *****************

chave*a = 3918.953523

a = 0.618034    pFracionaria = 0.953523

floor(tamTabela*pFracionaria) = 1907.000000

>>> Dispersao de 6341 = 1907

**********************************************************/
