/****
 *
 * Arquivo Macros.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2010
 * ltima modificao: 07/06/2010
 *
 * Descrio: Macros utilizadas pelo programa de disperso
 *            com encadeamento
 *
 ****/

#ifndef _Macros_H_   /* Previne incluso mltipla deste arquivo */
#define _Macros_H_

#include <stdlib.h> /* Funo exit()   */
#include <stdio.h>  /* Funo printf() */

   /* Macro utilizada em tratamento */
   /* de condies de exceo       */
#define ASSEGURA(condicao, msg) if (!(condicao)) {\
                                   fprintf(stderr, "\n%s\n", msg);\
                                   exit(1); \
                                }

   /* Fator de carga da tabela de disperso */
#define FATOR_DE_CARGA 1

   /* Nome do arquivo de dados */
#define NOME_ARQUIVO_BIN "I:\\Dados\\CEPs\\CEPs.bin"

   /* Nome do arquivo contendo as chaves da tabela de busca */
#define NOME_ARQUIVO_CHAVES "ListaDeChaves.txt"

   /* Nome do arquivo que armazena o nmero */
   /* de chaves em cada continer           */
#define NOME_ARQ_CHAVES  "ChavesEmConteineres.txt"

#define MAX_NOME  40 /* Nmero mximo de caracteres num nome */
#define TAM_UF     2 /* Nmero de dgitos num UF */
#define TAM_CEP    8 /* Nmero de dgitos num CEP */
#define MAX_COMP  60 /* Nmero mximo de caracteres */
                     /* num complemento             */
#define MAX_TIPO_LOG 10 /* Nmero mximo de caracteres */
                        /* num tipo de logradouro      */
#define TAM_DNE   16 /* Nmero de dgitos numa chave DNE */

   /* Tamanho do acrscimo do bloco usado para conter */
   /* uma linha a cada chamada de realloc()           */
#define TAMANHO_BLOCO 256

#endif
