/****
 *
 * Arquivo Tipos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2010
 * ltima modificao: 07/06/2010
 *
 * Descrio: Tipos utilizados pelo programa de disperso com
 *            encadeamento
 *
 ****/

#ifndef _Tipos_H_ /* Previne incluso mltipla deste arquivo */
#define _Tipos_H_

#include "Macros.h"  /* Macros usadas pelo programa */

typedef char tCEP[TAM_CEP + 1]; /* Tipo da chave */

   /* Tipo do contedo armazenado em cada n das listas (coletores) */
typedef struct {
           tCEP chave;  /* Chave de um registro          */
           int  indice; /* ndice do registro no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n de uma */
   /* lista encadeada que representa um coletor    */
typedef struct rotNoLSE {
           tCEP_Ind         conteudo;
           struct rotNoLSE *proximo;
        } tNoListaSE, *tListaSE;

   /* A tabela de disperso ser um array de listas encadeadas */
typedef tListaSE *tTabelaDE;

   /* Tipo de um ponteiro para uma funo de disperso */
typedef unsigned (*tFDispersao)(const char *);

   /* Tipo usado para armazenamento de */
   /* registros no arquivo binrio     */
typedef struct {
           int  numero;
           char UF[TAM_UF];
           int  localidadeNumero;
           char nomeAbr[MAX_NOME];
           char nome[MAX_NOME];
           int  bairroInicio;
           int  bairroFim;
           char CEP[TAM_CEP];
           char complemento[MAX_COMP];
           char tipoLogradouro[MAX_TIPO_LOG];
           char statusTipoLogradouro;
           char nomeSemAcento[MAX_NOME];
           char chaveDNE[TAM_DNE];
         } tRegistroCEP;

      /* Tipo usado para conter ndices de listas */
      /* e respectivos nmeros de elementos       */
typedef struct {
           int iLista; /* ndice da lista */
           int nElementos;
        } tElementosEmLista;

#endif
