/****
 *
 * Arquivo Registros.h: Interface do mdulo de processamento
 *                      de registros
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 20/04/2004
 * ltima modificao: 19/07/2008
 *
 ****/

#ifndef _Registros_H_  /* Previne incluso       */
#define _Registros_H_  /* mltipla deste arquivo */

/*********************** Includes *************************/

#include <stdio.h>

/***************** Constantes Simblicas ******************/

#define MAX_NOME 8 /* Tamanho mximo de um nome */

/****************** Definies de Tipos *******************/

typedef char tChave[MAX_NOME]; /* Tipo da chave */

typedef struct {
           tChave chave; /* Nome */
           int    idade;
         } tRegistro;

/******************* Aluses de Funes *******************/

extern FILE *AbreArquivo(const char *nome, const char *modo);
extern void FechaArquivo(FILE *stream, const char *nome);
extern void MoveApontador(FILE *stream, long bytes, int DeOnde);

extern void ExibeRegistro(const tRegistro *registro);
extern tRegistro *LeRegistro(tRegistro *regCEP);
extern tRegistro *SubstituiRegistro( tRegistro *novo,
                                     const tRegistro *antigo );
extern long TamanhoDeArquivo(FILE *stream);
extern int NumeroDeRegistros( FILE *stream, int tamRegistro );
extern tRegistro *LeRegistroEmArquivo( tRegistro *umRegistro,
                                       FILE *stream, int pos );
extern int ArquivoExiste(const char *nomeArq);

#endif

