#ifndef _TRIE_H_
#define _TRIE_H_

#include "Lista.h"

/***************** Constantes Simblicas ******************/

   /* Tamanho do alfabeto */
#define TAM_ALFABETO 'z' - 'a' + 1

/****************** Definies de Tipos *******************/

   /* Tipo de n da trie */
typedef struct rotNoTrieMachado {
           struct rotNoTrieMachado *filhos[TAM_ALFABETO];
           tListaSE                 valores;
        } tNoTrieMachado, *tTrieMachado;

/************************* Aluses ************************/

extern tTrieMachado IniciaTrieMachado(void);
extern void InsereTrieMachado( tNoTrieMachado *raiz, const char *chave,
                               const tConteudo *valor );
extern tListaSE BuscaTrieMachado(tNoTrieMachado *raiz, const char *chave);
extern void RemoveTrieMachado(tTrieMachado *pTrie, const char *chave);
extern int NumeroDeChavesTrieMachado(tNoTrieMachado *raiz);

#endif
