/****
 *
 * Arquivo: Eventos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 06/10/2017
 * ltima modificao: 06/10/2017
 *
 * Descrio: Interface do mdulo de eventos
 *
 ****/

#ifndef _Eventos_H_ /* Previne incluso mltipla deste arquivo */
#define _Eventos_H_

/****************** Definies de Tipos *******************/

#include "Tipos.h"  /* Definio do tipo tEvento */

/******************* Aluses de Funes *******************/

extern void ApresentaHora(int hora, int min);
extern int ComparaEventos(const void *e1, const void *e2);
extern tEvento *CriaEvento( tTipoDeEvento tipoDeEvento,
                            int instante, int nPessoas );
extern int NAleatorio(int m, int n);
extern double DRand(void);
extern double IntervaloExponencial(double intervaloMedio);
extern int ProcessaChegada(const tEvento *evento,
                           tLanchonete *lanchonete);
extern void ProcessaPedido( const tEvento *evento, int nSanduiches,
                            tLanchonete *lanchonete );
extern void ProcessaSaida( const tEvento *evento,
                           tLanchonete *lanchonete );
extern void DespachaEvento( tEvento *evento,
                            tLanchonete *lanchonete, tHeap *heap );

#endif
