/****
 *
 * Arquivo Macros.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2016
 * ltima modificao: 07/06/2016
 *
 * Descrio: Macros utilizadas pelo programa de ordenao de
 *            arquivos usando intercalao binria
 *
 ****/

#ifndef _Macros_H_   /* Previne incluso mltipla deste arquivo */
#define _Macros_H_

#include <stdlib.h> /* Funo exit()   */
#include <stdio.h>  /* Funo printf() */

   /* Macro utilizada em tratamento */
   /* de condies de exceo       */
#define ASSEGURA(condicao, msg) if (!(condicao)) {\
                                   fprintf(stderr, "\n%s\n", msg);\
                                   exit(1); \
                                }

/****************** Constantes Simblicas *****************/

#define N_CADEIRAS  10 /* Nmero de cadeiras da lanchonete */
#define MAX_PESSOAS_GRUPO 4 /* Nmero mximo de pessoas num grupo */
#define ATENDIMENTO 3.5 /* Tempo mdio de atendimento */
#define MAX_SAND  3 /* Nmero mximo de sanduches */
                    /* que uma pessoa pede         */
#define PERMANENCIA 7 /* Tempo mdio de permanncia de um */
                      /* grupo de clientes na lanchonete  */
#define PRECO    8.00  /* Preo de um sanduche */
#define MARGEM   0.30  /* Margem de lucro */
#define H_ABERTURA 10  /* Hora de abertura da lanchonete */
#define PERIODO   120 /* Perodo de funcionamento da lanchonete */
#define INTERVALO_CHEGADA 15 /* Intervalo de tempo mdio */
                             /* de chegada de clientes   */

#endif
