/****
 *
 * Arquivo: Registros.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/09/2017
 * ltima modificao: 16/09/2017
 *
 * Descrio: Interface de operaes com registros
 *
 ****/

#ifndef _Registros_H_
#define _Registros_H_

/***************** Constantes Simblicas ******************/

#define MAX_NOME  40 /* Nmero mximo de caracteres num nome */
#define TAM_UF     2 /* Nmero de dgitos num UF */
#define TAM_CEP    8 /* Nmero de dgitos num CEP */
#define MAX_COMP  60 /* Nmero mximo de caracteres */
                     /* num complemento             */
#define MAX_TIPO_LOG 10 /* Nmero mximo de caracteres */
                        /* num tipo de logradouro      */
#define TAM_DNE   16 /* Nmero de dgitos numa chave DNE */

/****************** Definies de Tipos *******************/

typedef struct {
           long numero;
           char UF[TAM_UF];
           int  localidadeNumero;
           char nomeAbr[MAX_NOME];
           char nome[MAX_NOME];
           int  bairroInicio;
           int  bairroFim;
           int  CEP;
           char complemento[MAX_COMP];
           char tipoLogradouro[MAX_TIPO_LOG];
           char statusTipoLogradouro;
           char nomeSemAcento[MAX_NOME];
           char chaveDNE[TAM_DNE];
         } tRegistroCEP;

/******************* Aluses de Funes *******************/

extern FILE *AbreArquivo(const char *nomeArq, const char *modo);
extern void FechaArquivo(FILE *stream, const char *nomeArq);
extern int TamanhoDeArquivo(FILE *stream);
extern int NumeroDeRegistros( FILE *stream, int tamRegistro );
extern int CriaArquivoApenasCEPs( const char *arqTexto,
                                  const char *arqBin, int maxRegs);

#endif
