/****
 *
 * Arquivo Registros.h: Interface do mdulo de processamento
 *                      de registros
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 20/04/2004
 * ltima modificao: 19/07/2008
 *
 ****/

#ifndef _Registros_H_  /* Previne incluso       */
#define _Registros_H_  /* mltipla deste arquivo */

/*********************** Includes *************************/

#include <stdio.h>
#include "Macros.h"  /* Macros    */
#include "Tipos.h"   /* Tipos     */

/******************* Aluses de Funes *******************/

extern FILE *AbreArquivo(const char *nome, const char *modo);
extern void FechaArquivo(FILE *stream, const char *nome);
extern void MoveApontador(FILE *stream, long bytes, int DeOnde);

extern void ExibeRegistro(const tRegistroMEC *registro);
extern tRegistroMEC *LeRegistro(tRegistroMEC *regCEP);
extern long TamanhoDeArquivo(FILE *stream);
extern int NumeroDeRegistros( FILE *stream, int tamRegistro );
extern tRegistroMEC *LeRegistroEmArquivo( tRegistroMEC *umRegistro,
                                       FILE *stream, int pos );
extern void InsereRegistroEmArquivo(tChave chave, FILE *stream);
extern int ArquivoExiste(const char *nomeArq);
extern int CriaArquivoBin( const char *nomeTexto, const char *nomeBin,
                           int maxRegistros );
extern void EscreveRegistro(const tRegistroMEC *registro, FILE *stream);
extern int ComparaPares(const void *e1, const void* e2);
extern char *NomeTemp(char *nome, const char *inicio, int max);
extern int MaxArquivosAbertos(void);
extern void MedidaDeTempo(const char *info);

#endif

