/****
 *
 * Arquivo Macros.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2016
 * ltima modificao: 15/05/2018
 *
 * Descrio: Macros utilizadas pelo programa de ordenao de
 *            arquivos usando intercalao binria
 *
 ****/

#ifndef _Macros_H_   /* Previne incluso mltipla deste arquivo */
#define _Macros_H_

#include <stdlib.h> /* Funo exit()   */
#include <stdio.h>  /* Funo printf() */

   /* Macro utilizada em tratamento */
   /* de condies de exceo       */
#define ASSEGURA(condicao, msg) if (!(condicao)) {\
                                   fprintf(stderr, "\n%s\n", msg);\
                                   exit(1); \
                                }

/****************** Constantes Simblicas *****************/

   /* Nmero mximo de arquivos temporrios gerados */
#define MAX_ARQ_TMP 999

   /* String com que inicia o nome    */
   /* de um arquivo temporrio gerado */
#define INI_ARQ_TMP "_tmp"

   /* Tamanho mximo de um nome de */
   /* arquivo temporrio gerado    */
#define MAX_NOME_TMP 10

   /* Nome do arquivo de texto contendo os registros */
#define NOME_ARQUIVO_REGS "../CensoMEC2012.txt"

   /* Nome do arquivo de dados original */
#define NOME_ARQUIVO_BIN "../CensoMEC2012.bin"

   /* Nome do arquivo de dados ordenado */
#define NOME_ARQUIVO_ORD "CensoMEC2012_Ord.bin"

   /* Nmero mximo de registros em cada srie */
#define MAX_REGISTROS 80000

#define MAX_NOME_IES     200 /* Tamanho mximo de */
                             /* um nome de IES    */
#define MAX_NOME_CURSO   200 /* Tamanho mximo de */
                             /* um nome de curso  */

#define MAX_UF_NASCIMENTO 30 /* Tamanho mximo   */
                             /* de um nome de UF */

#endif
