/****
 *
 * Arquivo: Registros.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/09/2017
 * ltima modificao: 13/05/2018
 *
 * Descrio: Interface de operaes com registros
 *
 ****/

#ifndef _Registros_H_
#define _Registros_H_

/************************ Includes ************************/

#include "Tipos.h"  /* Tipos usadas pelo programa */

/******************* Aluses de Funes *******************/

extern char *NomeTemp(char *nome, const char *inicio, int max);
extern int MaxArquivosAbertos(void);
extern FILE *AbreArquivo(const char *nomeArq, const char *modo);
extern void FechaArquivo(FILE *stream, const char *nomeArq);
extern void MoveApontador(FILE *stream, long bytes, int DeOnde);
extern long ObtemApontador(FILE *stream);
extern int ComparaRegistros(const void *r1, const void* r2);
extern int TamanhoDeArquivo(FILE *stream);
extern int NumeroDeRegistros( FILE *stream, int tamRegistro );
extern int ArquivoExiste(const char *nomeArq);
extern int CriaArquivoBin( const char *nomeTexto, const char *nomeBin,
                           int maxRegistros );

#endif
