/****
 *
 * Arquivo Tipos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2016
 * ltima modificao: 15/05/2018
 *
 * Descrio: Tipos utilizados pelo programa de ordenao de
 *            arquivos
 *
 ****/

#ifndef _Tipos_H_ /* Previne incluso mltipla deste arquivo */
#define _Tipos_H_

#include "Macros.h"  /* Macros usadas pelo programa */

   /* Tipo da chave */
typedef long tChave;

   /* Tipo usado para armazenamento de */
   /* registros no arquivo binrio     */
typedef struct {
           long codigoAluno;
           long chave; /* Chave */
           char nomeIES[MAX_NOME_IES];
           char nomeCurso[MAX_NOME_CURSO];
           char sexoAluno;
           int  idadeAluno;
           char UFNascimento[MAX_UF_NASCIMENTO];
           int  anoIngresso;
         } tRegistro;

   /* Tipo de varivel que contm informao sobre uma srie */
typedef struct {
           char       nome[MAX_NOME_TMP]; /* Nome do arquivo */
           FILE      *stream; /* Stream associado  srie */
           tRegistro *buffer; /* Buffer associado  srie */
           int        nRegistros; /* Nmero de registros que */
                                  /* se encontram no buffer  */
        } tSerie;

   /* Tipo de n e tipo de ponteiro para n de uma lista  */
   /* encadeada de informaes sobre arquivos temporrios */
typedef  struct no {
            tSerie     serie;
            struct no *proximo;
         } tNoSE, *tListaSE;

   /* Tipo de n de um heap */
typedef struct {
           tRegistro *elemento; /* Ponteiro para um registro */
                                /* de uma srie              */
           int        i; /* ndice do registro em seu buffer */
           tSerie    *serie; /* Ponteiro para a srie   */
                             /* qual o registro pertence */
        } tNoHeap;

   /* Tipo de um heap */
typedef struct {
           tNoHeap *itens;  /* Array de elementos do heap   */
           int      nItens; /* Nmero de elementos do array */
        } tHeap;

   /* Tipo de ponteiro para funo de  */
   /* comparao que compara registros */
typedef int (*tFCompara) (const void *, const void *);

#endif
