/****
 *
 * Arquivo ArvoreBM.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/08/2016
 * ltima modificao: 10/05/2018
 *
 * Descrio: Iterface das funes que implementam operaes
 *            de busca, insero e remoo usando rvores B+
 *
 ****/

#ifndef _ArvoreBM_H_ /* Previne incluso mltipla deste arquivo */
#define _ArvoreBM_H_

/*********************** Includes *************************/

#include <stdio.h> /* Tipo FILE                  */
#include "Tipos.h" /* Tipos usados pelo programa */

/************************* Aluses ************************/

extern void LeNoBM(FILE *stream, int pos, tNoBM *no);
extern int LeRaiz(const char *nomeArqRaiz);
extern void EscreveRaiz(const char *nomeArqRaiz, int raiz);
extern int BuscaBM( FILE *stream, const tNoBM* raiz,
                    tChave chave );
extern int InsereBM( tNoBM* raiz, tChaveIndice *chaveEIndice,
                     FILE *streamArvore );
extern int RemoveBM( FILE *stream, tNoBM *raiz, tChave chave );

extern int MenorChaveBM(FILE *stream);
extern int MaiorChaveBM(FILE *stream);
extern void EscreveChavesOrdenadas( const tNoBM *arvore,
                                    FILE *streamArv,
                                    FILE *streamChaves );
extern int BuscaIntervaloBM( tChave chave1, tChave chave2,
                             const tNoBM* arvore, FILE *streamArv,
                             FILE *streamChaves );
extern int ProfundidadeBM(FILE *stream);
extern int NumeroDeChavesBM(FILE *streamArv);
extern int NumeroDeFolhasBM(FILE *stream);
extern int NumeroDeNosInternosBM( FILE *stream );
extern int NumeroDeNosVaziosBM(FILE *stream);
extern int NumeroDeNosBM(FILE *stream);
extern void BulkloadingBM( FILE *streamReg, FILE *streamArv,
                         tNoBM *raiz );

#endif
